Imports System.Math

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.Black
        Me.ClientSize = New System.Drawing.Size(408, 341)
        Me.Name = "Form1"
        Me.Text = "Butterfly"

    End Sub

#End Region

    Private Const PERIOD As Integer = 24
    Private m_Colors(PERIOD - 1) As Color

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.Clear(Me.BackColor)

        ' Scale and translate.
        Const YMIN As Double = -4.4
        Const YMAX As Double = 2.7
        Const HGT As Double = YMAX - YMIN
        Dim wid As Double = HGT * Me.ClientSize.Width / Me.ClientSize.Height
        Dim scale As Double = Me.ClientSize.Height / HGT
        e.Graphics.ScaleTransform(scale, scale)
        e.Graphics.TranslateTransform(wid / 2, -YMIN)

        ' Draw the curve.
        Const PI As Double = 3.14159265
        Const NUM_LINES As Long = 5000
        Dim i As Long
        Dim t, expr, x, y As Double
        Dim pt0, pt1 As PointF

        ' Generate the points.
        t = 0
        expr = Exp(Cos(t)) - 2 * Cos(4 * t) - Sin(t / 12) ^ 5
        pt1 = New PointF(Sin(t) * expr, -Cos(t) * expr)

        Dim the_pen As New Pen(Color.Blue, 0)
        For i = 1 To NUM_LINES
            t = i * PERIOD * PI / NUM_LINES
            expr = Exp(Cos(t)) - 2 * Cos(4 * t) - Sin(t / 12) ^ 5
            pt0 = pt1
            pt1 = New PointF(Sin(t) * expr, -Cos(t) * expr)
            the_pen.Color = GetColor(t)
            e.Graphics.DrawLine(the_pen, pt0, pt1)
        Next i
        the_pen.Dispose()
    End Sub

    Private Function GetColor(ByVal t As Double) As Color
        Return m_Colors(Int(t / PI))
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.SetStyle( _
            ControlStyles.AllPaintingInWmPaint Or _
            ControlStyles.DoubleBuffer Or _
            ControlStyles.ResizeRedraw, _
            True)
        Me.UpdateStyles()

        m_Colors = New Color() { _
            Color.Pink, _
            Color.Red, _
            Color.Orange, _
            Color.Yellow, _
            Color.Lime, _
            Color.Cyan, _
            Color.Blue, _
            Color.Violet, _
            Color.Pink, _
            Color.Red, _
            Color.Orange, _
            Color.Yellow, _
            Color.Lime, _
            Color.Cyan, _
            Color.Blue, _
            Color.Violet, _
            Color.Pink, _
            Color.Red, _
            Color.Orange, _
            Color.Yellow, _
            Color.Lime, _
            Color.Cyan, _
            Color.Blue, _
            Color.Violet _
        }
    End Sub
End Class
